function createClass(parent)
	local newClass = {}
	function newClass:new(instance)
		local instance = instance or {}
		setmetatable(instance, {__index = newClass})
		return instance
	end

	if(parent ~= nil) then
		setmetatable(newClass, {__index = parent})
	end

	function newClass:getSelf()
		return newClass
	end

	function newClass:getParent()
		return baseClass
	end

	function newClass:isa(class)
		local tmp = newClass
		while(tmp ~= nil) do
			if(tmp == class) then
				return true
			end

			tmp = tmp:getParent()
		end

		return false
	end
	
	function newClass:setAttributes(attributes)
		for k, v in pairs(attributes) do
			newClass[k] = v
		end
	end

	return newClass
end

dofile(getDataDir() .. "lib/constant.lua")
dofile(getDataDir() .. "lib/function.lua")
dofile(getDataDir() .. "lib/compat.lua")
dofile(getDataDir() .. "lib/database.lua")

InitShopComunication = 0
OLD_LEVELS = {}


-- JAIL ################################################
-- Default jail time in seconds --
default_jail = 3
-- The permission you need to jail someone --
grouprequired = 4
-- StorageValue that the player gets --
jailedstoragevalue_time = 13001
jailedstoragevalue_bool = 13002
-- Set the position of the jail: --
jailpos = { x = 242, y = 697, z =7 }
jailfrompos = { x = 237, y = 693, z =7 }
jailtopos = { x = 245, y = 701, z =7 }
-- Set the position once unjailed: --
unjailpos = { x = 236, y = 697, z =7 }

-- TRAIN ###################################################
kick_position = {}
kick_position[1] = {{x=228,y=710,z=9}, {x=236,y=710,z=9},{x=244,y=711,z=9},{x=233,y=717,z=9},{x=244,y=718,z=9},{x=238,y=720,z=9},{x=227,y=721,z=9},{x=241,y=726,z=9},{x=233,y=728,z=9}}
trainstoragevalue_time = 13003
trainstoragevalue_room = 13004
trainstoragevalue_value = 13005


AURA_TIME = 1800

STORAGEVALUE_NEXT_REGEN_CHECK = 90
STORAGEVALUE_SHP = 100
STORAGEVALUE_MHP = 101
STORAGEVALUE_HHP = 102
STORAGEVALUE_SMP = 110
STORAGEVALUE_MMP = 111
STORAGEVALUE_HMP = 112
STORAGEVALUE_DEF_PSY = 120
STORAGEVALUE_DEF_FIRE = 121
STORAGEVALUE_DEF_ENERGY = 122
STORAGEVALUE_DEF_EARTH = 123
STORAGEVALUE_DEF_ICE = 124
STORAGEVALUE_DEF_HOLY = 125
STORAGEVALUE_DEF_DEATH = 126
STORAGEVALUE_SHP_TIME = 200
STORAGEVALUE_MHP_TIME = 201
STORAGEVALUE_HHP_TIME = 202
STORAGEVALUE_SMP_TIME = 210
STORAGEVALUE_MMP_TIME = 211
STORAGEVALUE_HMP_TIME = 212
STORAGEVALUE_DEF_PSY_TIME = 220
STORAGEVALUE_DEF_FIRE_TIME = 221
STORAGEVALUE_DEF_ENERGY_TIME = 222
STORAGEVALUE_DEF_EARTH_TIME = 223
STORAGEVALUE_DEF_ICE_TIME = 224
STORAGEVALUE_DEF_HOLY_TIME = 225
STORAGEVALUE_DEF_DEATH_TIME = 226
STORAGEVALUE_PROMOTION = 30018

TEXTCOLOR_BLUE = 5
TEXTCOLOR_LIGHTBLUE = 35
TEXTCOLOR_LIGHTGREEN = 30
TEXTCOLOR_GREEN = 54
TEXTCOLOR_TEAL = 65
TEXTCOLOR_PURPLE = 83
TEXTCOLOR_PLATINUMBLUE = 89
TEXTCOLOR_LIGHTGREY = 129
TEXTCOLOR_DARKRED = 144
TEXTCOLOR_RED = 180
TEXTCOLOR_ORANGE = 198
TEXTCOLOR_YELLOW = 210
TEXTCOLOR_WHITE_EXP = 215
TEXTCOLOR_NONE = 255

levelDoors = {1227, 1229, 1245, 1247, 1259, 1261, 3540, 3549, 5103, 5112, 5121, 5130, 5292, 5294, 6206, 6208, 6263, 6265, 6896, 6905, 7038, 7047, 8555, 8557}


-- arena script
InitArenaScript = 0
arena_room_max_time = 240
arenaKickPosition = {x=481, y=1088, z=6}

arena_monsters = {}

arena_monsters[42300] = 'frostfur' -- first monster from 1 arena
arena_monsters[42301] = 'bloodpaw'
arena_monsters[42302] = 'bovinus'
arena_monsters[42303] = 'achad'
arena_monsters[42304] = 'colerian the barbarian'
arena_monsters[42305] = 'the hairy one'
arena_monsters[42306] = 'axeitus headbanger'
arena_monsters[42307] = 'rocky'
arena_monsters[42308] = 'cursed gladiator'
arena_monsters[42309] = 'orcus the cruel'
arena_monsters[42310] = 'avalanche' -- first monster from 2 arena
arena_monsters[42311] = 'kreebosh the exile'
arena_monsters[42312] = 'the dark dancer'
arena_monsters[42313] = 'the hag'
arena_monsters[42314] = 'slim'
arena_monsters[42315] = 'grimgor guteater'
arena_monsters[42316] = 'drasilla'
arena_monsters[42317] = 'spirit of earth'
arena_monsters[42318] = 'spirit of water'
arena_monsters[42319] = 'spirit of fire'
arena_monsters[42320] = 'webster' -- first monster from 3 arena
arena_monsters[42321] = 'darakan the executioner'
arena_monsters[42322] = 'norgle glacierbeard'
arena_monsters[42323] = 'the pit lord'
arena_monsters[42324] = 'svoren the mad'
arena_monsters[42325] = 'the masked marauder'
arena_monsters[42326] = 'gnorre chyllson'
arena_monsters[42327] = "fallen mooh'tah master ghar"
arena_monsters[42328] = 'deathbringer'
arena_monsters[42329] = 'the obliverator'

function getArenaMonsterIdByName(name)
	name = string.lower(tostring(name))
	for i = 42300, 42329 do
		if tostring(arena_monsters[i]) == name then
			return i
		end
	end
	return 0
end


	function getPromotedVocation(id)
		if id == 1 then
			return 5
		elseif id == 2 then
			return 6
		elseif id == 3 then
			return 7
		elseif id == 4 then
			return 8
		end
		return id
	end

function getClosestFreeTile(c,p,t)
	return p
end

function getPlayerByName(name)
	local player = getCreatureByName(name)
	if(isPlayer(player) == TRUE) then
		return player
	end
	return 0
end

function getPlayerPzLock(cid)
	if isPlayerPzLocked(cid) == 1 then
		return 1
	else
		return 0
	end
end

function getPlayerSkullType(cid)
	return getCreatureSkullType(cid)
end

function getThingfromPos(pos)
	return getThingFromPos(pos)
end

function getItemName(itemid)
	return getItemNameById(itemid)
end

function doSetCreatureDropLoot(cid, doDrop)
	return doCreatureSetDropLoot(cid, doDrop)
end
function getItemWeight(itemid)
	return getItemWeightById(itemid)
end

function doPlayerSay(cid, text, class)
	return doCreatureSay(cid, text, class)
end

function getPlayerName(cid)
	return getCreatureName(cid)
end

function getPlayerPosition(cid)
	return getCreaturePosition(cid)
end

function getCreaturePos(cid)
	return getCreaturePosition(cid)
end

function doPlayerGiveItem(cid, itemid, count, charges)
	local hasCharges = (isItemRune(itemid) == TRUE or isItemFluidContainer(itemid) == TRUE)
	if(hasCharges and charges == nil) then
		charges = 1
	end
	while count > 0 do
		local tempcount = 1
		if(hasCharges) then
			tempcount = charges
		end
		if(isItemStackable(itemid) == TRUE) then
			tempcount = math.min(100, count)
   		end
	   	local ret = doPlayerAddItem(cid, itemid, tempcount)
	   	if(ret == LUA_ERROR) then
			ret = doCreateItem(itemid, tempcount, getPlayerPosition(cid))
		end
		if(ret ~= LUA_ERROR) then
			if(hasCharges) then
				count = count - 1
			else
				count = count - tempcount
			end
		else
			return LUA_ERROR
		end
	end
	return LUA_NO_ERROR
end

function doPlayerTakeItem(cid, itemid, count)
	if(getPlayerItemCount(cid,itemid) >= count) then
		while count > 0 do
			local tempcount = 0
			if(isItemStackable(itemid) == TRUE) then
				tempcount = math.min(100, count)
			else
				tempcount = 1
			end
			local ret = doPlayerRemoveItem(cid, itemid, tempcount)
			if(ret ~= LUA_ERROR) then
				count = count - tempcount
			else
				return LUA_ERROR
			end
		end
		if(count == 0) then
			return LUA_NO_ERROR
		end
	else
		return LUA_ERROR
	end
end

function doPlayerBuyItem(cid, itemid, count, cost, charges)
	if itemid == 2597 then
		if count > 5 then
			count = 5
		end
	end
	if(doPlayerRemoveMoney(cid, cost) == TRUE) then
		return doPlayerGiveItem(cid, itemid, count, charges)
	end
	return LUA_ERROR
end

function doPlayerBuyItemContainer(cid, container, itemid, count, cost, charges)
	if container == 2595 then
		if count > 5 then
			count = 5
		end
		if doPlayerRemoveMoney(cid, cost) == TRUE then
			for i = 1, count do
				local containerItem = doCreateItemEx(container, 1)
				doAddContainerItem(containerItem, itemid, charges)
				doPlayerAddItemEx(cid, containerItem, 1)
			end
			return LUA_NO_ERROR
		end
		return LUA_ERROR
	else
		if doPlayerRemoveMoney(cid, cost) == TRUE then
			for i = 1, count do
				local containerItem = doCreateItemEx(container, 1)
				for x = 1, getContainerCap(containerItem) do
					doAddContainerItem(containerItem, itemid, charges)
				end
				doPlayerAddItemEx(cid, containerItem, 1)
			end
			return LUA_NO_ERROR
		end
		return LUA_ERROR
	end
end

function doPlayerbuyContainer(cid, container, itemid, charges, cost, count)
	return doPlayerBuyItemContainer(cid, container, itemid, count, cost, charges)
end



function isSorcerer(cid)
	if(isPlayer(cid) == FALSE) then
		debugPrint("isSorcerer: Player not found.")
		return false
	end

	return (isInArray({1,5,9}, getPlayerVocation(cid)) == TRUE)
end

function isDruid(cid)
	if(isPlayer(cid) == FALSE) then
		debugPrint("isDruid: Player not found.")
		return false
	end

	return (isInArray({2,6,12}, getPlayerVocation(cid)) == TRUE)
end

function isPaladin(cid)
	if(isPlayer(cid) == FALSE) then
		debugPrint("isPaladin: Player not found.")
		return false
	end

	return (isInArray({3,7,13}, getPlayerVocation(cid)) == TRUE)
end

function isKnight(cid)
	if(isPlayer(cid) == FALSE) then
		debugPrint("isKnight: Player not found.")
		return false
	end

	return (isInArray({4,8,15,16}, getPlayerVocation(cid)) == TRUE)
end


-- shop system
dofile("./config.lua")
function getOfferOfPlayer(name)
	local offer = {}
	local result_items = db.getResult("SELECT `id`, `name`, `item_name`, `itemid`, `subType`, `count`, `price` FROM `ots_playersshopsystem` WHERE `name` = " .. db.escapeString(name) .. " AND `count` > '0' AND `itemid` != '66'")
	if(result_items:getID() ~= -1) then
		while(true) do
			table.insert(offer, {id = result_items:getDataInt("id"), name = result_items:getDataString("name"), item_name = result_items:getDataString("item_name"), itemid = result_items:getDataInt("itemid"), subType = result_items:getDataInt("subType"), count = result_items:getDataInt("count"), price = result_items:getDataInt("price")})
				if not(result_items:next()) then
					break
				end
		end
		result_items:free()
	end
	return offer
end

function getOfferOfItem(item_name)
	local offer = {}
    result_items = db.getResult("SELECT `id`, `name`, `item_name`, `itemid`, `subType`, `count`, `price` FROM `ots_playersshopsystem` WHERE `item_name` = " .. db.escapeString(item_name) .. " AND `count` > '0' AND `itemid` != '66' ORDER BY `price` ASC LIMIT 5")
	if(result_items:getID() ~= -1) then
		while(true) do
			table.insert(offer, {id = result_items:getDataInt("id"), name = result_items:getDataString("name"), item_name = result_items:getDataString("item_name"), itemid = result_items:getDataInt("itemid"), subType = result_items:getDataInt("subType"), count = result_items:getDataInt("count"), price = result_items:getDataInt("price")})
				if not(result_items:next()) then
					break
				end
		end
		result_items:free()
	end
	return offer
end

function addItemToOffer(name, itemid, subType, count)
	local inDB_id = 0
	local result_offers = db.getResult("SELECT `id`, `count` FROM `ots_playersshopsystem` WHERE `name` = " .. db.escapeString(name) .. " AND `itemid` = '" .. itemid .. "' AND `subType` = '" .. subType .. "' AND `itemid` != '66'")
	if(result_offers:getID() ~= -1) then
		inDB_id = result_offers:getDataInt("id")
		result_offers:free()
	end
	if inDB_id ~= 0 then
		db.executeQuery("UPDATE `ots_playersshopsystem` SET `count` = `ots_playersshopsystem`.`count` + " .. count .." WHERE `id` = '" .. inDB_id .. "' AND `subType` = '" .. subType .. "' AND `itemid` != '66'")
	else
		db.executeQuery("INSERT INTO `ots_playersshopsystem` (`id`, `name`, `item_name`, `itemid`, `subType`, `count`, `price`) VALUES (NULL, " .. db.escapeString(name) .. ", " .. db.escapeString(getItemNameById(itemid)) .. ", '" .. itemid .. "', '" .. subType .. "', '" .. count .. "', 1000000)")
	end
	return true
end

function removeItemsFromOffer(name, itemid, subType, count)
	db.executeQuery("UPDATE `ots_playersshopsystem` SET `count` = `ots_playersshopsystem`.`count` - " .. count .." WHERE `name` = " .. db.escapeString(name) .. " AND `itemid` = '" .. itemid .. "' AND `subType` = '" .. subType .. "' AND `itemid` != '66'")
	return true
end

function changePriceOfItem(name, itemid, subType, price)
	db.executeQuery("UPDATE `ots_playersshopsystem` SET `price` = " .. price .." WHERE `name` = " .. db.escapeString(name) .. " AND `itemid` = '" .. itemid .. "' AND `subType` = '" .. subType .. "' AND `itemid` != '66'")
	return true
end

function getItemWithId(id)
	local item = {id=0}
	local result_items = db.getResult("SELECT `id`, `name`, `item_name`, `itemid`, `subType`, `count`, `price` FROM `ots_playersshopsystem` WHERE `id` = '" .. id .. "' AND `count` > 0 AND `itemid` != '66'")
	if (result_items:getID() ~= -1) then
		item = {id = result_items:getDataInt("id"), name = result_items:getDataString("name"), item_name = result_items:getDataString("item_name"), itemid = result_items:getDataInt("itemid"), subType = result_items:getDataInt("subType"), count = result_items:getDataInt("count"), price = result_items:getDataInt("price")}
		result_items:free()
	end
	return item
end

function getItemWithItemId(name, itemid, subType)
	local item = {id=0}
	local result_items = db.getResult("SELECT `id`, `name`, `item_name`, `itemid`, `subType`, `count`, `price` FROM `ots_playersshopsystem` WHERE `name` = " .. db.escapeString(name) .. " AND `itemid` = '" .. itemid .. "' AND `subType` = '" .. subType .. "' AND `count` > 0 AND `itemid` != '66'")
	if(result_items:getID() ~= -1) then
		item = {id = result_items:getDataInt("id"), name = result_items:getDataString("name"), item_name = result_items:getDataString("item_name"), itemid = result_items:getDataInt("itemid"), subType = result_items:getDataInt("subType"), count = result_items:getDataInt("count"), price = result_items:getDataInt("price")}
		result_items:free()
	end
	return item
end

function getCash(name)
	local cash = 0
    local result_items = db.getResult("SELECT `id`, `count` FROM `ots_playersshopsystem` WHERE `name` = " .. db.escapeString(name) .. " AND `itemid` = '66'")
	if(result_items:getID() ~= -1) then
		cash = result_items:getDataInt("count")
		result_items:free()
    else
		db.executeQuery("INSERT INTO `tfs`.`ots_playersshopsystem` (`id`, `name`, `item_name`, `itemid`, `count`, `price`) VALUES ('', " .. db.escapeString(name) .. ", 'Player Cash', '66', '0', '0')")
	end
	return cash
end

function setCash(name, count)
	db.executeQuery("UPDATE `ots_playersshopsystem` SET `count` = " .. count ..", `price` = " .. count .." WHERE `name` = " .. db.escapeString(name) .. " AND `itemid` = '66'")
	return true
end

function addPlayerItemFromShop(cid, itemid, amount, subType)
	local amount = amount or 1
	local subType = subType or 0
	if(isItemStackable(itemid) == TRUE) then
		local item = doCreateItemEx(itemid, amount)
		local ret = doPlayerAddItemEx(cid, item)
		if(ret ~= RETURNVALUE_NOERROR) then
			return {}, 0
		end
		return {item}, amount
	end
	local items = {}
	local ret = 0
	local a = 0
	for i = 1, amount do
		items[i] = doCreateItemEx(itemid, subType)
		ret = doPlayerAddItemEx(cid, items[i])
		if(ret ~= RETURNVALUE_NOERROR) then
			break
		end
		a = a + 1
	end
	return items, a
end

-- gesior scripts
dontAttack = {'motyl', 'kot', 'pies'}

function isInTableString(tablee, stringg)
	stringg = string.lower(tostring(stringg))
	for i = 1, table.maxn(tablee) do
		if string.lower(tostring(tablee[i])) == stringg then
			return 1
		end
	end
	return 0
end


function jebGo(param)
	if (isPlayer(param.cid) == TRUE or isCreature(param.cid) == TRUE) and (isPlayer(variantToNumber(param.var)) == TRUE or isCreature(variantToNumber(param.var)) == TRUE) then
		local cidpos = getCreaturePosition(param.cid)
		local varpos = getCreaturePosition(variantToNumber(param.var))
		if getDistanceBetween(cidpos, varpos) < param.dist and varpos.z == cidpos.z then
			doCombat(param.cid, param.combat, param.var)
		end
	end
end

function getMonstersInArea3(cidpos, notCidArray)
	local playernumber = 0
	local playersInRange = {}
		local pPos = cidpos
		local positionsToCheck = {
		{x=pPos.x-3,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y+3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-3,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y+2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-3,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-3,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-3,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-3,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y-2,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-3,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-2,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x-1,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+2,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+3,y=pPos.y-3,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE}
		}
		for i = 1, table.maxn(positionsToCheck) do
			local creatureToHit = getThingfromPos(positionsToCheck[i])
			if creatureToHit ~= 0 then
				if getTilePzInfo(positionsToCheck[i]) == 0 then
					if (isCreature(creatureToHit.uid) == TRUE and creatureToHit.uid ~= cid and isInArray(notCidArray, creatureToHit.uid) ~= TRUE) then
						if isPlayer(creatureToHit.uid) == TRUE then
							if getPlayerStorageValue(creatureToHit.uid, 39005) ~= 1 then
								table.insert(playersInRange, creatureToHit.uid)
								playernumber = playernumber + 1
							end
						else
							table.insert(playersInRange, creatureToHit.uid)
							playernumber = playernumber + 1
						end
					end
				end
			end
		end
	return {list = playersInRange, number = playernumber}
end

function getMonstersInArea1(cidpos, notCidArray)
	local playernumber = 0
	local playersInRange = {}
		local pPos = cidpos
		local positionsToCheck = {
		{x=pPos.x-1,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y+1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-1,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		{x=pPos.x-1,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},{x=pPos.x+1,y=pPos.y-1,z=pPos.z,stackpos=STACKPOS_TOP_CREATURE},
		}
		for i = 1, table.maxn(positionsToCheck) do
			local creatureToHit = getThingfromPos(positionsToCheck[i])
			if creatureToHit ~= 0 then
				if getTilePzInfo(positionsToCheck[i]) == 0 then
					if (isCreature(creatureToHit.uid) == TRUE and creatureToHit.uid ~= cid and isInArray(notCidArray, creatureToHit.uid) ~= TRUE) then
						if isPlayer(creatureToHit.uid) == TRUE then
							if getPlayerStorageValue(creatureToHit.uid, 39005) ~= 1 then
								table.insert(playersInRange, creatureToHit.uid)
								playernumber = playernumber + 1
							end
						else
							table.insert(playersInRange, creatureToHit.uid)
							playernumber = playernumber + 1
						end
					end
				end
			end
		end
	return {list = playersInRange, number = playernumber}
end

function doDamageCreature(cid, damage, color, effect)
    damage = math.abs(damage)
    if getCreatureCondition(cid, CONDITION_MANASHIELD) == 1 then
        doSendMagicEffect(getThingPos(cid),CONST_ME_LOSEENERGY)
        doPlayerAddMana(cid, -math.min(damage, getPlayerMana(cid)))
        damage = damage - getPlayerMana(cid)
    end
    if damage > 0 then
        doCreatureAddHealth(cid, -damage)
        doSendAnimatedText(getThingPos(cid), damage, color or TEXTCOLOR_RED)
    end
    if effect then
        doSendMagicEffect(getThingPos(cid),effect)
    end
    return 1
end  

function addPremiumPoints(cid, value)
	local player_account_id = db.getResult("SELECT `account_id` FROM `players` WHERE `name` = " .. db.escapeString(getCreatureName(cid)) .. ";")
	if(player_account_id:getID() ~= -1) then
		local account_id =  player_account_id:getDataInt("account_id")
		player_account_id:free()
		local player_account = db.getResult("SELECT `premium_points` FROM `accounts` WHERE `id` = " .. account_id .. ";")
		if(player_account:getID() ~= -1) then
			local setpoints = player_account:getDataInt("premium_points") + value
			db.executeQuery("UPDATE `accounts` SET `premium_points` = " .. setpoints .. " WHERE `id` = " .. account_id .. ";")
			player_account:free()
			return TRUE
		end
	end
	return FALSE
end

function actualizeItemName(uid, returnname)
	if uid > 0 then
			local itemEx = getThing(doCreateItemEx(getThing(uid).itemid, getThing(uid).itemid))
			local itemTXT = ''
			local spearator = ''
			if getItemArmor(uid) - getItemArmor(itemEx.uid) ~= 0 then
				itemTXT = itemTXT .. spearator .. 'Arm: +'.. getItemArmor(uid) - getItemArmor(itemEx.uid)
				spearator = ', '
			end
			if getItemAttack(uid) - getItemAttack(itemEx.uid) ~= 0 then
				itemTXT = itemTXT .. spearator ..  'Atk: +'.. getItemAttack(uid) - getItemAttack(itemEx.uid)
				spearator = ', '
			end
			if getItemExtraAttack(uid) - getItemExtraAttack(itemEx.uid) ~= 0 then
				itemTXT = itemTXT .. spearator ..  'eAtk: +'.. getItemExtraAttack(uid) - getItemExtraAttack(itemEx.uid)
				spearator = ', '
			end
			if getItemDefense(uid) - getItemDefense(itemEx.uid) ~= 0 then
				itemTXT = itemTXT .. spearator .. 'Def: +'.. getItemDefense(uid) - getItemDefense(itemEx.uid)
				spearator = ', '
			end
			if getItemExtraDefense(uid) - getItemExtraDefense(itemEx.uid) ~= 0 then
				itemTXT = itemTXT .. spearator .. 'eDef: +'.. getItemExtraDefense(uid) - getItemExtraDefense(itemEx.uid)
				spearator = ', '
			end
			if getItemAttackSpeed(uid) > 0 then
				itemTXT = itemTXT .. spearator ..  'AtkT: -'.. (1000 - getItemAttackSpeed(uid)) / 10 .. '%'
				spearator = ', '
			end
			if getItemHealthMaxPercent(uid) - getItemHealthMaxPercent(itemEx.uid) > 0 then
				itemTXT = itemTXT .. spearator ..  'HP: +'.. getItemHealthMaxPercent(uid) .. '%'
				spearator = ', '
			end
			if getItemManaMaxPercent(uid) - getItemManaMaxPercent(itemEx.uid) > 0 then
				itemTXT = itemTXT .. spearator ..  'MP: +'.. getItemManaMaxPercent(uid) .. '%'
				spearator = ', '
			end
			if itemTXT ~= '' then
				setItemName(uid, getItemNameById(itemEx.itemid) .. " [" .. itemTXT .. "] ")
				return getItemNameById(itemEx.itemid) .. " [" .. itemTXT .. "] "
			else
				setItemName(uid, getItemNameById(itemEx.itemid))
				return getItemNameById(itemEx.itemid)
			end
	end
	return TRUE
end


function getBooleanFromString(str)
	return (str:lower() == "yes" or str:lower() == "true" or (tonumber(str) and tonumber(str) > 0)) and TRUE or FALSE
end

function doCopyItem(item, attributes)
	local attributes = attributes or FALSE

	local ret = doCreateItemEx(item.itemid, item.type)
	if(attributes == TRUE) then
		if(item.actionid > 0) then
			doSetItemActionId(ret, item.actionid)
		end
	end

	if(isContainer(item.uid) == TRUE) then
		for i = (getContainerSize(item.uid) - 1), 0, -1 do
			local tmp = getContainerItem(item.uid, i)
			if(tmp.itemid > 0) then
				doAddContainerItemEx(ret, doCopyItem(tmp, TRUE).uid)
			end
		end
	end

	return getThing(ret)
end

function doShowEffectOnPosition(param)
	local pos = getPlayerPosition(param.cid)
	local animtype = param.typee
	local posani = {x=param.x+pos.x, y=param.y+pos.y, z=pos.z}
	doSendMagicEffect(posani,animtype)
end